・問題文は2次元ですが、3次元FreeCADのマクロで、XY平面上に作図しました。
・タイトルを直しました。(2024-11-10)
正方形内に接する円「高校入試チャレンジ問題 正方形ABCDの面積は?」をsympyとFreeCADでやってみた。
正方形に内接する円「高校入試チャレンジ問題 正方形ABCDの面積は?」をsympyとFreeCADでやってみた。
オリジナル
・YUUU0123 様 (0:00〜2:48)
sympyで(オリジナル 様の方法を参考に)
ver0.1 相似で。
# ver0.1 相似で
from sympy import *
print("#",(2*sqrt(5))**2)
# 20
ver0.2 相似で。コメント様より。私は、裏向きの相似は苦手です。
# ver0.2
from sympy import *
EF=4
print("#",EF**2+(EF*Rational(1,2))**2)
# # 20
sympyで(いつもの方法で)
ver0.3 連立方程式で。半径r,B(-r,-r),E(r,0),F(x,y)とする.未知数3つ
# ver0.3
from sympy import *
var('x,y,r')
print("#",solve([Eq(x**2+y**2 ,r**2),
Eq((y-(-r))/(0-(-r)) ,(x-(-r))/(r-(-r))),
Eq((x-r)**2+(y-0)**2 ,4**2)
],(x,y,r))[0][2]**2*4)
# 20
ver0.4 CAD風に。円と直線の交点計算です。
・普通は?これでしょうか。 作図用です。
# ver0.4
from sympy import *
var('r',positive=True)
O,B,E=map(Point,[(0,0),(-r,-r),(r,0)])
F =Circle(O,r).intersection(Line(B,E))[1]
r_sol=solve(Eq(E.distance(F),4),r)[0]
print("#",r_sol**2*4)
# 20
ver0.5 CAD風に。単位円で。
・普通は?これでしょうか。単位円で交点計算。これも相似でした。
# ver0.4
from sympy import *
var('r',positive=True)
r1 =1
O,B,E=map(Point,[(0,0),(-r1,-r1),(r1,0)])
F =Circle(O,r1).intersection(Line(B,E))[0]
# print("#", E.distance(F) )
# print("#",solve(Eq(E.distance(F)/r1,4/r),r)[0] )
print ("#",solve(Eq(E.distance(F)/r1,4/r),r)[0]**2*4)
# 20
FreeCADのマクロで作図
・問題文は2次元ですが、3次元FreeCADのマクロで、XY平面に作図しました。
・計算部分は、Ver.0.4 の コピー貼り付けです。
import FreeCAD
import Part
import DraftTools
import Draft
import Mesh
############################################################################
# ver0.3
from sympy import *
var('r',positive=True)
O,B,E=map(Point,[(0,0),(-r,-r),(r,0)])
F =Circle(O,r).intersection(Line(B,E))[1]
r_sol=solve(Eq(E.distance(F),4),r)[0]
print("#",r_sol**2*4)
###########################################################################
rep ={r:r_sol}
B,E,F =B.subs(rep),E.subs(rep),F.subs(rep)
A,C,D=map(Point,[(-r_sol,r_sol),(r_sol,-r_sol),(r_sol,r_sol)])
############################################################################
# 3D作図 z=0 XY平面に作図しました。
# 2024-10-08 fontsize 追加しました。従来と互換性がありません。
# 2024-10-20 HR バグ対応済
############################################################################
def myDimension(fontsize,myExtOvershoot,start_point, end_point,HVP):
x1, y1 = start_point.args
x2, y2 = end_point.args
myFlipText = True
if HVP=="PL":
myP1 =Point(float(x1),float(y1))
myP2 =Point(float(x2),float(y2))
myFlipText = False
myExtOvershoot1=abs(myExtOvershoot)
elif HVP=="PR":
myP1 =Point(float(x1),float(y1))
myP2 =Point(float(x2),float(y2))
myFlipText = False
myExtOvershoot1=-abs(myExtOvershoot)
elif HVP=="VL":
if x1<x2 and y1<y2:
myP1 =Point(float(x1),float(y1))
myP2 =Point(float(x1),float(y2))
myExtOvershoot1= abs(myExtOvershoot)
myFlipText = False
elif x1<x2 and y1>y2:
myP1 =Point(float(x1),float(y1))
myP2 =Point(float(x1),float(y2))
myExtOvershoot1=-abs(myExtOvershoot)
elif x1>x2 and y1<y2:
myP1 =Point(float(x2),float(y1))
myP2 =Point(float(x2),float(y2))
myExtOvershoot1= abs(myExtOvershoot)
myFlipText = False
else:
myP1 =Point(float(x2),float(y1))
myP2 =Point(float(x2),float(y2))
myExtOvershoot1=-abs(myExtOvershoot)
elif HVP=="VR":
if x1<x2 and y1<y2:
myP1 =Point(float(x2),float(y1))
myP2 =Point(float(x2),float(y2))
myExtOvershoot1=-abs(myExtOvershoot)
myFlipText = False
elif x1<x2 and y1>y2:
myP1 =Point(float(x2),float(y1))
myP2 =Point(float(x2),float(y2))
myExtOvershoot1= abs(myExtOvershoot)
elif x1>x2 and y1<y2:
myP1 =Point(float(x1),float(y1))
myP2 =Point(float(x1),float(y2))
myExtOvershoot1=-abs(myExtOvershoot)
else:
myP1 =Point(float(x1),float(y1))
myP2 =Point(float(x1),float(y2))
myExtOvershoot1= abs(myExtOvershoot)
elif HVP=="HL":
if x1 < x2 and y1<y2:
myP1 =Point(float(x1),float(y2))
myP2 =Point(float(x2),float(y2))
myExtOvershoot1= abs(myExtOvershoot)
myFlipText = False
elif x1 < x2 and y1>y2:
myP1 =Point(float(x1),float(y1))
myP2 =Point(float(x2),float(y1))
myExtOvershoot1= abs(myExtOvershoot)
myFlipText = False
elif x1 > x2 and y1<y2:
myP1 =Point(float(x1),float(y1))
myP2 =Point(float(x2),float(y1))
myExtOvershoot1= abs(myExtOvershoot)
else:
myP1 =Point(float(x1),float(y2))
myP2 =Point(float(x2),float(y2))
myExtOvershoot1= abs(myExtOvershoot)
elif HVP=="HR":
if x1<x2 and y1<=y2:
myP1 =Point(float(x1),float(y1))
myP2 =Point(float(x2),float(y1))
myExtOvershoot1=-abs(myExtOvershoot)
myFlipText = False
elif x1<x2 and y1>y2:
myP1 =Point(float(x1),float(y2))
myP2 =Point(float(x2),float(y2))
myExtOvershoot1=-abs(myExtOvershoot)
myFlipText = False
elif x1>x2 and y1<y2:
myP1 =Point(float(x1),float(y2))
myP2 =Point(float(x2),float(y2))
myExtOvershoot1=-abs(myExtOvershoot)
else:
myP1 =Point(float(x1),float(y1))
myP2 =Point(float(x2),float(y1))
myExtOvershoot1=-abs(myExtOvershoot)
else:
print("")
myM =myP1.midpoint(myP2)
myT =myM+myExtOvershoot1*((myP1-myM).unit).rotate( -pi/2 )
dimension = Draft.makeDimension(
FreeCAD.Vector(myP1.x, myP1.y, 0), # 点1の座標
FreeCAD.Vector(myP2.x, myP2.y, 0), # 点2の座標
FreeCAD.Vector(float(myT.x),float(myT.y),0) # 矢印の位置を中央に設定
)
# Ext Overshootを設定
dimension.ViewObject.ExtOvershoot = -float(myExtOvershoot)
dimension.ViewObject.FlipText = myFlipText
# 矢印のスタイルを設定
dimension.ViewObject.ArrowType = "Arrow" # 矢印のタイプを "Arrow" に設定
dimension.ViewObject.ArrowSize = fontsize/5
dimension.ViewObject.TextSpacing = 0
dimension.ViewObject.LineColor = (0.0, 1.0, 0.0) # 緑色
dimension.ViewObject.FontSize = fontsize # フォントサイズを指定
def myXYZ2Txt_2D(A):
return ""
def myXYZ2Txt_XY_2D(A):
return '(' + str(A.x) + ',' + str(A.y) + ')'
def myTxtXYZ_2D(fontsize,A,myWedgei):
P5x=float(A.x)
P5y=float(A.y)
P5z=0.0
p5 = FreeCAD.Vector(P5x, P5y, P5z)
myText = Draft.makeText(myWedgei, p5)
myText.Label = myWedgei
FreeCADGui.ActiveDocument.ActiveObject.FontSize = str(fontsize,)+' mm'
return
def myTxtXYZ_S_2D(fontsize,*xy_tx):
for i in range(1,int(len(xy_tx)/2)+1):
myTxtXYZ_2D(fontsize,xy_tx[2*i-2],xy_tx[2*i-1]+myXYZ2Txt_2D(xy_tx[2*i-2]) )
return
def myTxtXYZ_XY_S_2D(fontsize,*xy_tx):
for i in range(1,int(len(xy_tx)/2)+1):
myTxtXYZ_2D(fontsize,xy_tx[2*i-2],xy_tx[2*i-1]+myXYZ2Txt_XY_2D(xy_tx[2*i-2]) )
return
def myTxtXYZ_MoveY_2D(fontsize,MoveY,A,myWedgei):
P5x=float(A.x)
P5y=float(A.y)+MoveY
P5z=0.0
p5 = FreeCAD.Vector(P5x, P5y, P5z)
myText = Draft.makeText(myWedgei, p5)
myText.Label = myWedgei
FreeCADGui.ActiveDocument.ActiveObject.FontSize = str(fontsize,)+' mm'
return
def myTxtXYZ_XY_S_MoveY_2D(fontsize,MoveY,*xy_tx):
for i in range(1,int(len(xy_tx)/2)+1):
myTxtXYZ_MoveY_2D(fontsize,MoveY,xy_tx[2*i-2],xy_tx[2*i-1]+myXYZ2Txt_XY_2D(xy_tx[2*i-2]) )
return
############################################################################
# 3D作図 z=0 XY平面に作図しました。
############################################################################
# 円の作図 FrecCADのdocより
# https://wiki.freecad.org/Macro_Circle
def Freecad3D_circle(x=0.0,y=0.0,z=0.0,radius=0.0,diameter=0.0,circumference=0.0,area=0.0,startangle=0.0,endangle=0.0,arc=0.0,anglecenter=0.0,cord=0.0,arrow=0.0,center=0,placemObject=""):
from math import sqrt, pi
if placemObject == "":
pl = FreeCAD.Placement()
pl.Rotation = FreeCADGui.ActiveDocument.ActiveView.getCameraOrientation()
pl.Base = FreeCAD.Vector(x,y,z)
else:
pl = FreeCAD.Placement()
pl = placemObject # placement imposted
if diameter != 0: # with diameter
radius = diameter / 2.0
elif circumference != 0: # with circumference
radius = (circumference / pi) / 2.0
elif area != 0: # with area
radius = sqrt((area / pi))
elif (cord != 0) and (arrow != 0): # with cord and arrow
radius = ((arrow**2) + (cord**2) / 4.0) / (arrow*2)
elif (arc != 0) and (anglecenter != 0): # with arc and anglecenter central in degrees
radius = ((360/anglecenter)*arc) / pi/2.0
if endangle != 0:
startangle = endangle - anglecenter
endangle = anglecenter + startangle
startangle = endangle - anglecenter
if radius != 0:
try:
Draft.makeCircle(radius,placement=pl,face=False,startangle=startangle,endangle=endangle,support=None)
if center != 0:
x=pl.Base.x
y=pl.Base.y
z=pl.Base.z
Draft.makePoint(x,y,z)
except Exception:
App.Console.PrintError("Unexpected keyword argument" + "\n")
App.ActiveDocument.recompute()
else:
App.Console.PrintMessage("Unexpected keyword argument" + "\n")
App.Console.PrintMessage("circle(x,y,z,radius,diameter,circumference,area,startangle,endangle,[arc,anglecenter],[cord,arrow],center,placemObject)" + "\n")
App.Console.PrintMessage("circle(radius=10.0,placemObject=App.Placement(App.Vector(11,20,30), App.Rotation(30,40,0), App.Vector(0,0,0)))" + "\n")
return
def myCircle_2D(myCi):
x=float(myCi.center.x)
y=float(myCi.center.y)
r=float(myCi.radius)
Freecad3D_circle(
x=float(x),y=float(y),z=0.0,
radius=float(abs(r)),
center=1,
placemObject=App.Placement(App.Vector(float(x),float(y),0),
App.Rotation(0,0,0),App.Vector(0,0,0)))
return
def myLine_2D(A,B):
Ax,Ay,Az=float(A.x),float(A.y),0.0
Bx,By,Bz=float(B.x),float(B.y),0.0
pl = FreeCAD.Placement()
pl.Rotation.Q = (0.4247081540122249, 0.17592004639554645, 0.33985110062924484, 0.8204732460821097)
pl.Base = FreeCAD.Vector(-3.9166066876399563, -2.1670824762243774, 1.7495260956243028)
points = [FreeCAD.Vector(Ax,Ay,Az), FreeCAD.Vector(Bx,By,Bz)]
line = Draft.make_wire(points, placement=pl, closed=False, face=True, support=None)
Draft.autogroup(line)
return
def myLine_S_2D(*args):
for i in range(1,len(args)):
myLine_2D(args[i-1],args[i])
return
def myLine_C_2D(*args):
for i in range(1,len(args)):
myLine_2D(args[i-1],args[i])
myLine_2D(args[i],args[0])
return
def myLine_H_2D(*args):
for i in range(1,len(args)):
myLine_2D(args[0],args[i])
return
##################################################################################
myCircle_2D (Circle(O,r_sol))
myLine_C_2D (A,B,C,D)
myLine_S_2D (B,E,F)
#
myFontsize =0.3
myOvershoot=myFontsize*8
myTxtXYZ_XY_S_2D(myFontsize,O,"O",A,"A",B,"B",C,"C",D,"D")
myTxtXYZ_XY_S_2D(myFontsize,E,"E",F,"F")
myDimension(myFontsize,myOvershoot,F,E,"PR")
####################################################################################
doc = App.activeDocument()
#App.ActiveDocument.addObject("App::Origin", "Origin")
#App.ActiveDocument.getObject('Origin').Visibility = True
App.ActiveDocument.recompute()
Gui.activeDocument().activeView().viewAxonometric()
Gui.SendMsgToActiveView("ViewFit")
isometric方向?です。(省略)
拡大図
いつものリンク? sympyの実行環境と 参考のおすすめです。
・以下ができたら、助かります。指定と全部です